#ifdef BEEPLITE
/*
 * beeplite.c
 */
#include "copyright.h"

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <ctype.h>
#ifndef SERVER
#include "Wlib.h"
#endif
#include "defs.h"
#include "struct.h"
#include "data.h"


rcdlite (dist)
     struct distress *dist;	/* the info */
{
   char message[100];
   int len = 0;

   if ((dist == NULL) ||
/*       (dist->sender == me->p_no) ||		*/
       (distlite[dist->distype] == NULL)) {
     return;
   }

   len = makedistress (dist, message, distlite[dist->distype]);

   if (len <= 0)
     return;

   makelite (dist, message);
}


litedefaults()
{
    if (distlite[take] == NULL) distlite[take] = "/c/l";
    if (distlite[base_ogg] == NULL) distlite[base_ogg] = "/g/m";
    if (distlite[pickup] == NULL) distlite[pickup] = "/p";
    if (distlite[generic] == NULL) distlite[generic] = "%?%S=SB%{/c%}";
}

liteplanet(l)
struct planet *l;
{
  if (lite_planets)
  {
    emph_planet_seq_n [l->pl_no] = beep_lite_cycle_time_planet;
    l->pl_flags |= PLREDRAW ;   /* Leave redraw on until done highlighting */
    l->pl_flags |= PLCLEAR ;    /* Leave redraw on until done highlighting */
  }
}                                                                              

liteplayer (j)
  struct player *j;
{
  if (!j || (j->p_flags & PFCLOAK))
    return;

  if (j == me && lite_self == 0)
    return;
  
  redrawPlayer [j->p_no] = 1;
  emph_player_seq_n [j->p_no] = beep_lite_cycle_time_player;
}

/* small permutation on makedistress.  Searches for the highliting
** arguments, ignores everything else.
*/

makelite (dist, pm)
     struct distress *dist;	/* the info */
     char *pm;			/* macro to parse, used for distress and macro */
{
  struct player *sender;
  struct player *j;
  struct planet *l;
  char *strcap ();
  char c;


  sender = &players[dist->sender];

  if (!(*pm))
    {
      return (0);
    }


  /* first step is to substitute variables */
  while (*pm)
    {
      if (*pm == '/')
	{
	  pm++;

	  if (!pm)
	      continue;

	  switch (c = *(pm++))
	    {

	    case 'P':		/* push player id into buf */
	    case 'G':		/* push friendly player id into buf */
	    case 'H':		/* push enemy target player id into buf */

	    case 'p':		/* push player id into buf */
	    case 'g':		/* push friendly player id into buf */
	    case 'h':		/* push enemy target player id into buf */

	      switch (c)
		{
		case 'p':
		  j = &players[dist->tclose_j];
		  break;
		case 'g':
		  j = &players[dist->tclose_fr];
		  break;
		case 'h':
		  j = &players[dist->tclose_en];
		  break;
		case 'P':
		  j = &players[dist->close_j];
		  break;
		case 'G':
		  j = &players[dist->close_fr];
		  break;
		default:
		  j = &players[dist->close_en];
		  break;
		}
	      liteplayer(j);
	      break;

            case 'B':           /* highlites planet nearest sender */
	    case 'b':		
	      l = &planets[dist->close_pl];
	      liteplanet(l);
	      break;
	    case 'L':           /* highlites planet nearest pointer */
	    case 'l':		
	      l = &planets[dist->tclose_pl];
	      liteplanet(l);
	      break;
	    case 'U':		/* highlites enemy nearest pointer */
	    case 'u':		
	      j = &players[dist->tclose_en];
	      liteplayer(j);
	      break;
	    case 'c':		/* highlites sender */
	    case 'I':		
	    case 'i':		
	      liteplayer(sender);
	      break;
	    case 'M':		/* highlites me */
	    case 'm':
	      if (lite_self)
		liteplayer(me);
	      break;
	    case '0':
	      if (lite_sounds)
		W_Beep();	    
	      break;
	    default:
/* try to continue
** bad macro character is skipped entirely,
** the message will be parsed without whatever argument has occurred. - jn
*/
	      warning ("Bad Macro character in distress!");
	      fprintf (stderr,"Unrecognizable special character in distress pass 1: %c\n", *(pm-1));
	      break;     
	    }
	}
	else
	{
            pm++;
	}

    }


  return (1);
}


#endif /* BEEPLITE */

