/*
 * data.c
 * 
 * $Log: data.c,v $
 * Revision 1.6  1993/10/05  16:40:38  hadley
 * checkin
 *
 * Revision 1.6  1993/10/05  16:38:08  hadley
 * checkin
 *
 */
#include "copyright.h"

#include <stdio.h>
#include <sys/types.h>
#include "Wlib.h"
#include "defs.h"
#include "struct.h"
#include "data.h"

#ifdef DYNAMIC_BITMAPS
#include "bitmapstuff.h"
#endif

struct player  *players;
struct player  *me = NULL;
struct torp    *torps;
struct plasmatorp *plasmatorps;
struct status  *status;
struct ship    *myship;
struct stats   *mystats;
struct planet  *planets;
struct phaser  *phasers;
struct message *messages;
struct mctl    *mctl;
struct memory   universe;

int		F_gen_distress = 0;   /* generic distress/macro system support */
int		fastQuit=0;
int             oldalert = 0;
int             remap[16] =
{0, 1, 2, 0, 3, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 0};
int             messpend;
int             lastcount;
int             mdisplayed;
int             redrawall;
int             udcounter;
int             showTractorPressor = 1;
int             showLock = 3;
int             extraBorder = 1;
int             fillTriangle = 0;
/* udp options */
int             tryUdp = 1;
struct plupdate pl_update[MAXPLANETS];
#ifdef SHIFTED_MOUSE
char buttonmap[12] =
{'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0' };
#else
char            buttonmap[4] =
{'\0', '\0', '\0', '\0'};
#endif
int             lastm;
int             mapmode = 2;
int             namemode = 1;
int             showStats = 1;
int             showShields = 1;
int             warncount = 0;
int             warntimer = -1;
int             infomapped = 0;
int             keeppeace = 0;
#ifdef GATEWAY
unsigned LONG   netaddr = 0;	/* for blessing */
#endif

int             msgBeep = 1;	/* ATM - msg beep */
#ifdef SCAN
int             scanplayer;	/* who to scan */
int             scanmapped = 0;	/* ATM - scanners */
#endif

int             showlocal = 1;
int             showgalactic = 1;
char           *title = NULL;
char           *shipnos = "0123456789abcdefghijklmnopqrstuvwxyz";
int             sock = -1;
int             xtrekPort = -1;
int             queuePos = -1;
int             pickOk = -1;
int             lastRank = -1;
int             promoted = 0;
int             loginAccept = -1;
unsigned        localflags = 0;
int             tournMask = 15;
int             nextSocket;	/* socket to use when we get ghostbusted... */
int             updatePlayer[MAXPLAYER];	/* Needs updating on player
						 * list */
char           *serverName = NULL;
int             loggedIn = 0;
int             reinitPlanets = 0;
int             redrawPlayer[MAXPLAYER];	/* Needs redrawing on
						 * galactic map */
int             lastUpdate[MAXPLAYER] =
{0};				/* Last update of this player */
int             timerDelay = 200000;	/* micro secs between updates */
int             reportKills = 1;/* report kill messages? */
int		phaserWindow = 0;

#ifdef RECORD
FILE           *recordFile = NULL;	/* recorder */
int             recordGame = 0;	/* We don't record the game by default */
#endif
#ifdef MOO
#ifdef LOGMESG
FILE           *logFile = NULL;	/* log message to this file */
int             logMess = 0;	/* We don't log message by default */
#endif
#ifdef MOOBITMAPS
int             myPlanetBitmap = 0;	/* Use the new planet bitmaps by
					 * default --- NOT! */
#endif
int             continueTractor = 1;	/* Continous vis T/P beams by default */
int             showMotdOnQ = 1;/* Show the MOTD while waiting */
#endif				/* MOO */

int             showTractor = 1;/* show visible tractor beams */
int             commMode = 0;	/* UDP: 0=TCP only, 1=UDP updates */
int             commModeReq = 0;/* UDP: req for comm protocol change */
int             commStatus = 0;	/* UDP: used when switching protocols */
int             commSwitchTimeout = 0;	/* UDP: don't wait forever */
int             udpTotal = 1;	/* UDP: total #of packets received */
int             udpDropped = 0;	/* UDP: count of packets dropped */
int             udpRecentDropped = 0;	/* UDP: #of packets dropped recently */
int             udpSock = -1;	/* UDP: the socket */
int             udpDebug = 0;	/* UDP: debugging info on/off */
int             udpClientSend = 1;	/* UDP: send our packets using UDP? */
int             udpClientRecv = 1;	/* UDP: receive with simple UDP */
int             udpSequenceChk = 1;	/* UDP: check sequence numbers */
#ifdef GATEWAY
int             gw_serv_port, gw_port, gw_local_port;	/* UDP */
char           *gw_mach = NULL;	/* UDP */
#endif

int             debug = 0;

int             messageon = 0;
int             warp = 0;

#ifdef RSA
/* char testdata[16]; Not needed in RSA 2.0 */
int             RSA_Client = 1;
#endif

#ifdef NBT
struct macro_list macro[MAX_MACRO];	/* NBT 2/26/93 */
int             MacroMode = 0;
int             macrocnt = 0;
#endif

#ifdef NBTDIST
/* defaults should say quasi intelligent things */
/*
 * note that all are enabled by default but some say nothing- this is to
 * allow the WTEMPED or ETEMPED message to appear if necessary
 */
struct distress_list distress[2] =
{
   {0, 101, 0, 101, 0, 101, 0, 101, -1, 40, 0, 101,
    "SHLD OUT", "%d%%shld", "Shld ok",
    "Dam. ok", "%d%%dam", "DAMAGED",
    "_", "_", "_",
    "_", "_", "_",
    "_", "%d Armies", "%d ARMS!",
    "NO GAS", "%d%%fuel", "Fuel ok",
    1, 1, 1, 1, 1, 1},
   {0, 101, 0, 66, 0, 85, 0, 101, -1, 40, 15, 101,
    "SHLD OUT", "%d%%shld", "Shld ok",
    "_", "%d%%dam", "WRP 1! %d%% dam",
    "_", "%d%%wtmp", "%d%% WTMP HIGH",
    "_", "_", "_",
    "_", "%d armies", "%d ARMS!",
    "GAS LOW %d%%", "_", "_",
    1, 1, 1, 1, 1, 1}};
#endif

#ifdef GALAXY
extern double   Sin[], Cos[];
#endif				/* GALAXY */

W_Icon          stipple, clockpic, icon;

W_Color         borderColor, backColor, textColor, myColor, warningColor,
                shipCol[5], rColor, yColor, gColor, unColor, foreColor;

#ifdef VSHIELD_BITMAPS
int             VShieldBitmaps = 0;
#endif

#ifndef FONT_BITMAPS
W_Icon          expview[EX_FRAMES];
W_Icon          sbexpview[SBEXPVIEWS];
W_Icon          cloud[NUMDETFRAMES];
W_Icon          plasmacloud[NUMDETFRAMES];
W_Icon          etorp, mtorp;
W_Icon          eplasmatorp, mplasmatorp;
#ifdef VSHIELD_BITMAPS
W_Icon          shield[SHIELD_FRAMES];
#else
W_Icon          shield;
#endif
W_Icon		cloakicon;

#ifndef DYNAMIC_BITMAPS
W_Icon          fed_bitmaps[NUM_TYPES][VIEWS], kli_bitmaps[NUM_TYPES][VIEWS], rom_bitmaps[NUM_TYPES][VIEWS], ori_bitmaps[NUM_TYPES][VIEWS], ind_bitmaps[NUM_TYPES][VIEWS];
#else
W_Icon          ship_bitmaps[NUM_BITMAP_TYPES][VIEWS];
#endif

#ifdef MOO
/* ISAE: use #define to specify the size */
W_Icon          bplanets[NUM_PLANET_BITMAPS];
W_Icon          mbplanets[NUM_PLANET_BITMAPS];
W_Icon          bplanets2[NUM_PLANET_BITMAPS2];
W_Icon          mbplanets2[NUM_PLANET_BITMAPS2];
#ifdef MOOBITMAPS
W_Icon          bplanets3[NUM_PLANET_BITMAPS2];	/* isae:  Added this */
W_Icon          mbplanets3[NUM_PLANET_BITMAPS2];	/* isae: Added this */
#endif				/* MOOBITMAPS */
#else				/* MOO */
W_Icon          bplanets[6];
W_Icon          mbplanets[6];
W_Icon          bplanets2[8];
W_Icon          mbplanets2[8];
#endif				/* MOO */

#endif	/* FONT_BITMAPS */

char lastMessage[100];

char *classes[] = {"SC", "DD", "CA", "BB", "AS", "SB", "GA", "AT"};
char            teamlet[] =
{'I', 'F', 'R', 'X', 'K', 'X', 'X', 'X', 'O', 'X', 'X', 'X',
 'X', 'X', 'X', 'A'};
char           *teamshort[16] =
{"IND", "FED", "ROM", "X", "KLI", "X", "X", "X", "ORI",
 "X", "X", "X", "X", "X", "X", "ALL"};
char            pseudo[PSEUDOSIZE];
char            loginnam[PSEUDOSIZE];
#ifdef AUTOLOGIN
char            defpasswd[PSEUDOSIZE];
#endif

struct rank     ranks[NUMRANKS] =
{
   {0.0, 0.0, 0.0, "Ensign"},
   {2.0, 1.0, 0.0, "Lieutenant"},
   {4.0, 2.0, 0.8, "Lt. Cmdr."},
   {8.0, 3.0, 0.8, "Commander"},
   {15.0, 4.0, 0.8, "Captain"},
   {20.0, 5.0, 0.8, "Flt. Capt."},
   {25.0, 6.0, 0.8, "Commodore"},
   {30.0, 7.0, 0.8, "Rear Adm."},
   {40.0, 8.0, 0.8, "Admiral"}};

W_Window        messagew, w, mapw, statwin, baseWin, infow, iconWin, tstatw, war,
                warnw, helpWin, teamWin[4], qwin, messwa, messwt, messwi,
                messwk, planetw, playerw, rankw, optionWin = 0, reviewWin;
#ifdef XTREKRC_HELP
W_Window	defWin;
#endif
#ifdef SCAN
W_Window	scanw, scanwin;
#endif
W_Window        udpWin;
W_Window	phaserwin;

#ifdef EM
int             sortPlayers = 0;
#endif

#ifdef ROTATERACE
int             rotate = 0;
int             rotate_deg = 0;
#endif

#ifdef NETSTAT
int             netstat = 0;
int             netstatfreq = 5;
W_Window        lMeter;
int             updatespeed = 5;
#endif

#ifdef PING
int             ping = 0;	/* to ping or not to ping */
LONG            packets_sent = 0;	/* # all packets sent to server */
LONG            packets_received = 0;	/* # all packets received */
W_Window        pStats;
#endif

int             use_msgw = 0;   /* send last message to message window */
int             phas_msg = 0;  /* send phaser point messages to windows */
int             phas_msgi = 0;

#ifdef BD
int             bd = 0;
#endif

#ifdef SHORT_PACKETS
int             tryShort = 1;	/* for .xtrekrc option */
int             recv_short = 0;
int             recv_short_opt = 0;

int             recv_threshold = 0;
char            recv_threshold_s[8] =
{'0', '\0'};
#endif

int		tclock=2;

#ifdef NEW_PL
int		new_playerlist=0;
#endif

int		new_messages = 1;

#ifdef XSIG
int		critical = 0;
#endif

int		max_fd = 3;

#ifdef FEATURE
int report_features = 0;
/* jn - SMARTMACRO */
int 		MacroNum = 0;
int		F_UseNewMacro=1;
int		F_UseSmartMacro=1;
int		F_why_dead=0;
W_Window	macroWin = NULL;
int		macrokey = 'X';
char *singleMacro = NULL;

/* RCD modifications */
/* tried to automate this as much as possible... the entries are
   ** the character, string identifier, and the default macro for
   ** each distress type.
 */
 
/* the index into distmacro array should correspond with the correct dist_type */
 
#define NUM_DIST 27
 
 
struct dmacro_list dist_prefered[NUM_DIST];
 
/* the index into distmacro array should correspond with the correct dist_type */
/* the character specification is ignored now, kept here anyway for reference */
struct  dmacro_list dist_defaults[] = {
        { 'X', "no zero", "this should never get looked at" },
        { 't', "taking", " %T%c->%O (%S) Carrying %a to %l%?%n>-1%{ @ %n%}\0"},
        { 'o', "ogg", " %T%c->%O Help Ogg %p at %l\0" },
        { 'b', "bomb", " %T%c->%O %?%n>4%{bomb %l @ %n%!bomb%}\0"},
        { 'c', "space_control", " %T%c->%O Help Control at %L\0" },
        { '1', "save_planet", " %T%c->%O Help at %l! %?%a>0%{ (have %a arm%?%a=1%{y%!ies%}) %} %s%% shld, %d%% dam, %f%% fuel\0" },
        { '2', "base_ogg", " %T%c->%O Sync with --]> %g <[-- OGG ogg OGG base!!\0" },
        { '3', "help1", " %T%c->%O Help me! %d%% dam, %s%% shd, %f%% fuel %a armies.\0" },
        { '4', "help2", " %T%c->%O Help me! %d%% dam, %s%% shd, %f%% fuel %a armies.\0" },
        { 'e', "escorting", " %T%c->%O ESCORTING %g (%d%%D %s%%S %f%%F)\0" },
        { 'p', "ogging", " %T%c->%O Ogging %h\0" },
        { 'm', "bombing", " %T%c->%O Bombing %l @ %n\0" },
        { 'l', "controlling", " %T%c->%O Controlling at %l\0" },
        { '5', "asw", " %T%c->%O Anti-bombing %p near %b.\0" } ,
        { '6', "asbomb", " %T%c->%O DON'T BOMB %l. Let me bomb it (%S)\0" } ,
        { '7', "doing1", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel\0" } ,
        { '8', "doing2", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal.  %d%% dam, %s%% shd, %f%% fuel\0" } ,
        { 'f', "free_beer", " %T%c->%O %p is free beer\0" },
        { 'n', "no_gas", " %T%c->%O %p @ %l has no gas\0" },
        { 'h', "crippled", " %T%c->%O %p @ %l crippled\0" },
        { '9', "pickup", " %T%c->%O %p++ @ %l\0" },
        { '0', "pop", " %T%c->%O %l%?%n>-1%{ @ %n%}!\0"},
        { 'F', "carrying", " %T%c->%O %?%S=SB%{Your Starbase is c%!C%}arrying %?%a>0%{%a%!NO%} arm%?%a=1%{y%!ies%}.\0" },
        { '@', "other1", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)\0" },
        { '#', "other2", " %T%c->%O (%i)%?%a>0%{ has %a arm%?%a=1%{y%!ies%}%} at lal. (%d%%D, %s%%S, %f%%F)\0" },
        { 'E', "help", " %T%c->%O Help(%S)! %s%% shd, %d%% dmg, %f%% fuel,%?%S=SB%{ %w%% wtmp,%!%}%E%{ ETEMP!%}%W%{ WTEMP!%} %a armies!\0" },
        { '\0', '\0', '\0'},
};
 
struct dmacro_list *distmacro = dist_defaults;
 
int sizedist = sizeof (dist_defaults);

#ifdef BEEPLITE

char *distlite[NUM_DIST] = {
    NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
    NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
    NULL, NULL, NULL, NULL, NULL, NULL, NULL
    };

int DefLite = 0;
int UseLite = 0;

int     emph_planet_seq_n[MAXPLANETS] = {0,} ;
int     emph_player_seq_n[MAXPLAYER]  = {0,} ;
W_Icon emph_planet_seq[10] ;
W_Icon emph_player_seq[10] ;
W_Icon emph_player_seql [10] ;
int beep_lite_cycle_time_player = 10;
int beep_lite_cycle_time_planet = 10;

int beep_lite_enablable = 0;
int lite_players_map = 1;
int lite_players_local = 1;
int lite_self = 1;
int lite_planets = 1;
int lite_sounds = 1;
#endif /* BEEPLITE */

#endif /* FEATURE */

int		abbr_kmesg=0;

int		maskrecip=0;

#ifdef DASHBOARD
int		dashboard=0;
#endif

int		plshowstatus=1;

#ifdef NEW_DASHBOARD_2
/* KRP */
/* Variation on dashboard. */
int cup_half_full = 0;
#endif

#ifdef IGNORE_SIGNALS_SEGV_BUS
/* KRP */
/* Handle (hopefully) non-fatal segmentation and bus faults. */
int ignore_signals = 0;
#endif

#ifdef MOTION_MOUSE
/* KRP */
int 		motion_mouse = 0;
int		steering_mouse = 1;
int 		user_motion_thresh = 16;
int 		motion_mouse_enablable = 1;
#endif

#ifdef SHIFTED_MOUSE
/* KRP */
int 		extended_mouse = 0;
#endif

#ifdef TNG_FED_BITMAPS
int use_tng_fed_bitmaps = 0;
W_Icon tng_fed_bitmaps [NUM_TYPES][VIEWS];
#endif

#ifdef VARY_HULL
W_Icon hull[8];
int vary_hull = 0;
#endif

#ifdef CONTROL_KEY
int use_control_key = 1;
#endif

#ifdef ZZ_BITMAPS
W_Icon bplanets4 [8];	 
W_Icon mbplanets4 [8];		 
#endif

#ifdef REFRESH_INTERVAL
int refresh_interval = 0;
#endif

#ifdef PLIST
int newPlist = 0;
char plist[80] = {'\0'};
int no_init_plist = 0;
#endif

#ifdef KEEP_INFO
int keepInfo = 15;	/* how many updates to keep infowins 6/1/93 LAB */
#endif

#ifdef CLOAK_CHARS
char cloakChars[3] = "??";
#endif

#ifdef SHOW_IND
int showIND = 0;
#endif

int enemyPhasers = 1;

#ifdef META
int usemeta = 0;
int num_servers = 0;
struct servers serverlist[20];
char *keystrings[] =
{"OPEN:", "Wait queue:", "Nobody"};
W_Window metaWin = NULL;
char meta_server [256] = "";
#endif

#ifdef ROMVLVS_BITMAPS
int ROMVLVS = 0;
W_Icon ROMVLVS_bitmap [VIEWS];
#endif

#ifdef MAKE_XTREKRC
int showDefaults = 0;
int use_cow_literc = 0;
int cow_literc_override = 0;
#endif

#ifdef BUTTON_KEYMAP_WINDOW
W_Window but_key_win = NULL;
#endif

#ifdef USE_TR_PORTS
int useTRPorts = 0;
#endif

#ifdef MAP_NAMES
int draw_map_names = 1;

int show_owner_tact = 0;
int show_owner_map = 0;
W_Icon show_owner_map_bitmaps [ORI + 1];
#endif

#ifdef SHOW_MY_SPEED
int showMySpeed = 0;
#endif

#ifdef SBHOURS
int SBhours = 0;
#endif

#ifdef JUBILEE_PHASERS
int jubilee_phasers = 0;
#endif

#ifdef MULTILINE_MACROS
int multiline_enabled = 0;
int ignore_multilines = 0;
#endif

/* When you enter game send request for full update SRS 3/15/94 */
int askforUpdate = 0;

#ifdef CLOAK_MAXWARP
int cloak_maxwarp = 0;
#endif

#ifdef WARP_DEAD
int dead_warp = 0;
#endif

#ifdef SHOW_FUEL_ON_LOCAL
int show_fuel_on_local = 0;
#endif
